function[Uni,UniD,GammaD,Uni2_1,UniD2_1,Uni2_2,UniD2_2,DeltaD1,DeltaD2,Beta01mat,Beta02mat,logProb,ADgam,Sgam,ADdel1,Sdel1,...
    ADdel2,Sdel2,acceptgam,acceptdelta1,acceptdelta2,acceptBeta1,acceptBeta2,GammaA,DeltaA1,DeltaA2]= ...
bvsmefMRI2(X,Y,Z,gamprec,deltaprec1,deltaprec2,nmetr,r1,r2,Beta01prec,Beta02prec,pPar,eta,mu,pd,a,b,ak,bk,Phi,delW,aj,bj,n,p,q,Beta01mat,Beta02mat,MRF,h,h1)


if isempty(gamprec)
    randp=randperm(p); gamprec=zeros(1,p); onenum=randp(1:r1); gamprec(onenum)=1;
end
if isempty(deltaprec1)
    randp=randperm(q); deltaprec1=zeros(1,q); onenum=randp(1:r2); deltaprec1(onenum)=1;
end
if isempty(deltaprec2)
    randp=randperm(q); deltaprec2=zeros(1,q); onenum=randp(1:r2); deltaprec2(onenum)=1;
end

disp(' ')
disp('------- RUNNING METROPOLIS ...')
disp(' ')

% --- Initialize parameters
nPar=1000;
GammaA{1} = num2str(find(gamprec));   GammaD{1} = num2str(find(gamprec));
DeltaA1{1} = num2str(find(deltaprec1)); DeltaD1{1} = num2str(find(deltaprec1));
DeltaA2{1} = num2str(find(deltaprec2)); DeltaD2{1} = num2str(find(deltaprec2));
Uni(1) = r1; UniD(1) = r1; Uni2_1(1) = r2; UniD2_1(1) = r2; Uni2_2(1) = r2; UniD2_2(1) = r2; 
logProb = zeros(1,nmetr+1); 
ADgam = []; Sgam = []; ADdel1 = []; Sdel1 = []; ADdel2 = []; Sdel2 = []; conta = 1; contaD = 1;

n1 = sum(Y==0); n2 = n-n1; Y1 = find(Y==0); Y2 = find(Y==1);
varSel = sum(gamprec); PhiS = Phi(logical(gamprec),logical(gamprec));
B01pS = Beta01prec(logical(gamprec)); B02pS = Beta02prec(logical(gamprec));


% ---- Calculate the marginal log-likelihood
Avet = zeros(p,1); B1vet = zeros(p,1); B2vet = zeros(p,1); D1vet = zeros(p,1); D2vet = zeros(p,1);
Zd1 = Z(Y1,logical(deltaprec1)); Zd2 = Z(Y2,logical(deltaprec2)); nSnp1 = sum(deltaprec1); nSnp2 = sum(deltaprec2);
a_p = a + n/2; ak_p1 = ak + n1/2; ak_p2 = ak + n2/2; aj_p = aj + 1/2;

for i=1:p
    Xj = X(:,i); b_p = b+(Xj'*Xj)/2;
    Xj1 = X(Y1,i); Xj2 = X(Y2,i);
    bj_p1 = bj+(Beta01prec(i)^2)/2;  bj_p2 = bj+(Beta02prec(i)^2)/2;
    bk_p1 = bk + ((Xj1-ones(n1,1)*Beta01prec(i))'*inv(1/h*eye(n1)+Zd1*Zd1')*(Xj1-ones(n1,1)*Beta01prec(i)))/2;
    bk_p2 = bk + ((Xj2-ones(n2,1)*Beta02prec(i))'*inv(1/h*eye(n2)+Zd2*Zd2')*(Xj2-ones(n2,1)*Beta02prec(i)))/2;
    
    Avet(i) = -n*log(sqrt(2*pi))+a*log(b)-a_p*log(b_p)+gammaln(a_p)-gammaln(a);
    B1vet(i) = -n1*log(sqrt(2*pi))-nSnp1/2*log(h)+ak*log(bk)-ak_p1*log(bk_p1)-gammaln(ak)+gammaln(ak_p1)- 0.5*log(det(1/h*eye(n1)+Zd1*Zd1'));
    B2vet(i) = -n2*log(sqrt(2*pi))-nSnp2/2*log(h)+ak*log(bk)-ak_p2*log(bk_p2)-gammaln(ak)+gammaln(ak_p2)- 0.5*log(det(1/h*eye(n2)+Zd2*Zd2'));
    D1vet(i) = -log(sqrt(2*pi))+aj*log(bj)-aj_p*log(bj_p1)-gammaln(aj)+gammaln(aj_p);
    D2vet(i) = -log(sqrt(2*pi))+aj*log(bj)-aj_p*log(bj_p2)-gammaln(aj)+gammaln(aj_p);
end

C = -varSel*log(pi)-varSel*log(h1)+(delW+varSel+1)*log(det(PhiS))+2*(gammaln((delW+varSel)/2)-2*gammaln((delW+varSel-1)/2))...
    -(delW+varSel)/2*(log(det(PhiS+(B01pS*B01pS')./h1))+log(det(PhiS+(B02pS*B02pS')./h1)));

loglik = C + sum(Avet(logical(gamprec==0)))+sum(B1vet(logical(gamprec)))+sum(B2vet(logical(gamprec)))+sum(D1vet(logical(gamprec==0)))+...
    sum(D2vet(logical(gamprec==0)));

% Prior on $\delta$
snpSel1 = sum(deltaprec1);
pridel1 = snpSel1*log(pd)+(q-snpSel1)*log(1-pd);
snpSel2 = sum(deltaprec2);
pridel2 = snpSel2*log(pd)+(q-snpSel2)*log(1-pd);

% Prior on $\gamma$
prigam = mu*varSel+eta*gamprec*MRF*gamprec';

tic;
Uni = zeros(1,nmetr); Uni2 = zeros(1,nmetr); 
probprec = loglik + pridel1 + pridel2 + prigam; logProb(conta) = probprec;
NaccB = 0; acceptgam = 0; acceptdelta1 = 0; acceptdelta2 = 0; acceptBeta1 = 0; acceptBeta2 = 0;

while conta<nmetr+1
    
%-------------------- Metropolis (nPar iterations)    
[UniSt,UniSt2_1,UniSt2_2,ProbSt,GammaSt,DeltaSt1,DeltaSt2,loglik,probprec,prigam,pridel1,pridel2,Beta01matSt,Beta02matSt,storeADgam,...
    storeSgam,storeADdel1,storeADdel2,storeSdel1,storeSdel2,acceptgam,acceptdelta1,acceptdelta2,acceptBeta1,acceptBeta2,Avet,B1vet,B2vet,C,D1vet,D2vet,NaccB]= ...
metrofMRI2(X,Y1,Y2,Z,gamprec,deltaprec1,deltaprec2,loglik,probprec,prigam,pridel1,pridel2,Beta01prec,Beta02prec,pPar,eta,mu,pd,ak,...
bk,Phi,delW,aj,bj,n1,n2,p,q,MRF,acceptgam,acceptdelta1,acceptdelta2,acceptBeta1,acceptBeta2,nPar,Avet,B1vet,B2vet,C,D1vet,D2vet,NaccB,h,h1);

logProb(conta+1:conta+nPar)=ProbSt; 
Uni(conta+1:conta+nPar) = UniSt; Uni2_1(conta+1:conta+nPar) = UniSt2_1; Uni2_2(conta+1:conta+nPar) = UniSt2_2;
indiciDgam = sort([storeADgam storeSgam]); indiciDdel1 = sort([storeADdel1 storeSdel1]); indiciDdel2 = sort([storeADdel2 storeSdel2]);
GammaStD = GammaSt(indiciDgam); DeltaStD1 = DeltaSt1(indiciDdel1); DeltaStD2 = DeltaSt2(indiciDdel2);
GammaA = cat(1,GammaA,GammaSt); DeltaA1 = cat(1,DeltaA1,DeltaSt1); DeltaA2 = cat(1,DeltaA2,DeltaSt2);
GammaD = cat(1,GammaD,GammaStD); DeltaD1 = cat(1,DeltaD1,DeltaStD1); DeltaD2 = cat(1,DeltaD2,DeltaStD2);
UniD = [UniD, UniSt(indiciDgam)]; UniD2_1 = [UniD2_1, UniSt2_1(indiciDdel1)]; UniD2_2 = [UniD2_2, UniSt2_2(indiciDdel2)];
ADgam = cat(2, ADgam, (conta-1)+storeADgam);  Sgam=cat(2, Sgam, (conta-1)+storeSgam);
ADdel1 = cat(2, ADdel1, (conta-1)+storeADdel1);  Sdel1=cat(2, Sdel1, (conta-1)+storeSdel1);
ADdel2 = cat(2, ADdel2, (conta-1)+storeADdel2);  Sdel2=cat(2, Sdel2, (conta-1)+storeSdel2);
conta = conta+nPar; 
gamprec = zeros(1,p); deltaprec1 = zeros(1,q); deltaprec2 = zeros(1,q);
gamprec(str2num(GammaSt{nPar})) = ones(1,length(str2num(GammaSt{nPar}))); 
deltaprec1(str2num(DeltaSt1{nPar})) = ones(1,length(str2num(DeltaSt1{nPar})));
deltaprec2(str2num(DeltaSt2{nPar})) = ones(1,length(str2num(DeltaSt2{nPar})));
Beta01mat(:,(conta-nPar):(conta-1)) = Beta01matSt;
Beta02mat(:,(conta-nPar):(conta-1)) = Beta02matSt;
Beta01prec = Beta01matSt(:,end); Beta02prec = Beta02matSt(:,end);

disp(sprintf('It.: %3d, T: %3.1fs, acpdel1: %1.3f, acpdel2: %1.3f, acpgam: %1.3f, acpB1: %1.2f, acpB2: %1.2f, Uni: %2d,Uni21: %2d,Uni22: %2d',conta-1,toc,(acceptdelta1/(conta-1)),(acceptdelta2/(conta-1)),(acceptgam/(conta-1)),(acceptBeta1/NaccB),(acceptBeta2/NaccB),Uni(conta-1),Uni2_1(conta-1),Uni2_2(conta-1))); tic;  
end

% ------ Calculate acceptance ratios
acceptgam = acceptgam/nmetr; acceptdelta1 = acceptdelta1/nmetr; acceptdelta2 = acceptdelta2/nmetr;
acceptBeta1 = acceptBeta1/NaccB; acceptBeta2 = acceptBeta2/NaccB;

disp(' ')
disp('--- End.') 
