function [B1vetnew,B2vetnew,pridelnew1,pridelnew2] = mmlfMRIdel2(gamprec,deltanew1,deltanew2,X,Z,Y1,Y2,n1,n2,Beta01prec,Beta02prec,q,ak,bk,pd,varSel,B1vet,B2vet,h)

% ---- calculate the marginal log-likelihood
ak_p1 = ak + n1/2; ak_p2 = ak + n2/2;
Zd1 = Z(Y1,logical(deltanew1)); Zd2 = Z(Y2,logical(deltanew2));
B1vetnew = B1vet; B2vetnew = B2vet; gamSel = find(gamprec);
nSnp1 = sum(deltanew1);
nSnp2 = sum(deltanew2);

for i=1:varSel
    j = gamSel(i);
    Xj1 = X(Y1,j); Xj2 = X(Y2,j);
    bk_p1 = bk + ((Xj1-ones(n1,1)*Beta01prec(j))'*inv(1/h*eye(n1)+Zd1*Zd1')*(Xj1-ones(n1,1)*Beta01prec(j)))/2;
    bk_p2 = bk + ((Xj2-ones(n2,1)*Beta02prec(j))'*inv(1/h*eye(n2)+Zd2*Zd2')*(Xj2-ones(n2,1)*Beta02prec(j)))/2;
    
    B1vetnew(j) = -n1*log(sqrt(2*pi))-nSnp1/2*log(h)+ak*log(bk)-ak_p1*log(bk_p1)-gammaln(ak)+gammaln(ak_p1)- 0.5*log(det(1/h*eye(n1)+Zd1*Zd1'));
    B2vetnew(j) = -n2*log(sqrt(2*pi))-nSnp2/2*log(h)+ak*log(bk)-ak_p2*log(bk_p2)-gammaln(ak)+gammaln(ak_p2)- 0.5*log(det(1/h*eye(n2)+Zd2*Zd2'));
end

% Prior on $\delta$
snpSel1 = sum(deltanew1);
pridelnew1 = snpSel1*log(pd)+(q-snpSel1)*log(1-pd);

snpSel2 = sum(deltanew2);
pridelnew2 = snpSel2*log(pd)+(q-snpSel2)*log(1-pd);
